
Core - Bug # 23575

Status: Resolved Priority: Must have
Author: Xavier Perseguers Category: DBAL
Created: 2010-09-21 Assigned To: Xavier Perseguers
Updated: 2013-12-08 Due date:
TYPO3 Version:
PHP Version:
Complexity:
Is Regression:
Sprint Focus:
Subject: Allow DBAL to interact with EM to configure remapping
Description

When using an Oracle DBMS, length of identifiers is limited to 30 characters. DBAL can be configured to automatically remap table
and field names to shorter or other ones.

To work, the remapping configuration must be available before the corresponding table has been created.

Idea is that EM triggers DBAL before an extension is installed. This would allow to determine whether remapping should be used
(typically if DBMS is Oracle and table/field names longer than 30 characters). In such case, and if the remapping configuration is not
already present in localconf.php (if administrator already "prepared" the remapping), it should provide a middle step for the installation
where DBAL could propose a mapping configuration to be written to localconf.php.

User should be able to modify the automatic mapping configuration before it is written to localconf.php. After that, EM should go on as
usual and show table to be created/fields to be added.

Example of remapping configuration:

$TYPO3_CONF_VARS['EXTCONF']['dbal']['mapping'] = array(
    'cachingframework_cache_hash' => array(
        'mapTableName' => 'cf_cache_hash',
    ),
    'cachingframework_cache_hash_tags' => array(
        'mapTableName' => 'cf_cache_hash_tags',
    ),
    'cachingframework_cache_pages' => array(
        'mapTableName' => 'cf_cache_pages',
    ),
    'tx_templavoila_datastructure' => array(
        'mapTableName' => 'tx_templavoila_ds',
    ),
);
(issue imported from #M15755)

Related issues:
related to Core - Bug # 23877: Add DB structure update pre-processing hook in EM Resolved 2010-10-30
related to Core - Feature # 23911: Allow array as localconf.php configuration... Closed 2010-11-02
related to Core - Bug # 16292: installer doesn't cope with maximum table and ... New 2006-06-27

Associated revisions
Revision 06c7af84 - 2011-08-26 12:12 - Xavier Perseguers
[BUGFIX] Allow DBAL to interact with EM to configure remapping

Interface changed during Extension Manager refactoring.

Change-Id: I42e9ab7ed5513bdd031e186592b1768a7a00cedd
Fixes: #23575
Related: #23877
Releases: 4.5, 4.6

Revision 38f7ed45 - 2011-08-26 12:13 - Xavier Perseguers

[BUGFIX] Allow DBAL to interact with EM to configure remapping

Interface changed during Extension Manager refactoring.

Change-Id: I5cb2f78e889f3abfce8e50aa7c455c79e52ad9ce
Fixes: #23575
Related: #23877
Releases: 4.5, 4.6

History
#1 - 2010-10-31 10:06 - Xavier Perseguers

Just uploaded some ongoing work to show how this could be done.

#2 - 2010-11-14 13:26 - Xavier Perseguers

Committed to DBAL trunk (rev. 40177)

#3 - 2011-03-29 17:44 - Susanne Moog
- Target version deleted (4.5.0)

#4 - 2011-08-26 12:00 - Xavier Perseguers
- Status changed from Closed to New
- Priority changed from Should have to Must have
- TYPO3 Version set to 4.5

This is open again because the corresponding part in EM was removed and refactoring changed the method signature.

#5 - 2011-08-26 12:00 - Xavier Perseguers
- Tracker changed from Feature to Bug
- Project changed from Core to DBAL
- Category deleted (DBAL)

#6 - 2011-08-26 12:12 - Mr. Hudson

Patch set 1 of change I42e9ab7ed5513bdd031e186592b1768a7a00cedd has been pushed to the review server.

2015-08-04 2/3



It is available at http://review.typo3.org/4616

#7 - 2011-08-26 12:13 - Mr. Hudson

Patch set 1 of change I5cb2f78e889f3abfce8e50aa7c455c79e52ad9ce has been pushed to the review server.
It is available at http://review.typo3.org/4617

#8 - 2011-08-26 13:33 - Xavier Perseguers
- Status changed from New to Under Review

#9 - 2011-08-29 06:54 - Xavier Perseguers
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

#10 - 2013-12-08 11:42 - Michael Stucki
- Project changed from DBAL to Core

#11 - 2013-12-08 11:44 - Michael Stucki
- Category set to DBAL
